/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Sałaciński   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

//KDE Includes
#include <klocale.h>

//kX Generator Includes
#include <qstring.h>
#include "kxgenerator.h"
#include "ServerLayoutWidget.h"
#include "MouseWidget.h"
#include "GlobalFunctions.h"
#include "KeyboardWidget.h"
#include "VideocardWidget.h"
#include "MonitorWidget.h"
#include "AdvancedWidget.h"
#include "ChangeEntriesDialog.h"
#include "PropertiesDialog.h"

#include "Xorg.h"
#include "properties.h"

#include "ScreenModesEditor.h"


#define ERR "ERROR"

QString kXGeneratorMain :: Locale (int n)
{
if (n == 0) { return i18n("Server Layout"); }
if (n == 1) { return i18n("Pointer"); }
if (n == 2) { return i18n("Keyboard"); }
if (n == 3) { return i18n("Video Card"); }
if (n == 4) { return i18n("Display"); }
if (n == 5) { return i18n("Advanced Settings"); }
if (n == 6) { return i18n("Accept"); }
if (n == 7) { return i18n("Quit"); }
if (n == 8) { return i18n("Do you really want to quit? Settings will NOT be saved!"); }
if (n == 9) { return i18n("Quit?"); }
if (n == 10) { return i18n("About..."); }
if (n == 11) { return i18n("Choose ServerLayout"); }
if (n == 12) { return i18n("General options"); }
if (n == 13) { return i18n("Default Server Layout:"); }



if (n == 500) { return i18n("kX Generator"); }
return ERR;
}

QString ServerLayoutWidget :: Locale (int n)
{
if (n == 0) { return i18n("Server Layout"); }
if (n == 1) { return i18n("Add"); }
if (n == 2) { return i18n("Change entries..."); }
if (n == 3) { return i18n("Pointers"); }
if (n == 4) { return i18n("Keyboards"); }
if (n == 5) { return i18n("Screens"); }
if (n == 6) { return i18n("Add..."); }
if (n == 7) { return i18n("Remove"); }
if (n == 8) { return i18n("Rename"); }
if (n == 9) { return i18n("Here you can modify all pointer devices that will be connected when X start with current Server Layout. Check \"Core pointer\" checkbox if you want pointer to emit core events."); }
if (n == 10) { return i18n("Core Pointer"); }
if (n == 11) { return i18n("Here you can modify all keyboard devices that will be connected when X start with current Server Layout. Check \"Core pointer\" checkbox if you want pointer to emit core events."); }
if (n == 12) { return i18n("Here you can modify screens connected to server."); }
if (n == 13) { return i18n("This pointer is already on the list."); }
if (n == 14) { return i18n("There should be at least one pointer entry."); }
if (n == 15) { return i18n("This keyboard is already on the list."); }
if (n == 16) { return i18n("There should be at least one keyboard entry."); }
if (n == 17) { return i18n("This screen is already on the list."); }
if (n == 18) { return i18n("There should be at least one screen entry."); }
if (n == 19) { return i18n("Remove"); }
if (n == 20) { return i18n("Add new section"); }
if (n == 21) { return i18n("Select name for new section:"); }
if (n == 22) { return i18n("Rename section"); }
if (n == 23) { return i18n("Select new name for new section %1:"); }
if (n == 24) { return i18n("This identifier is already used by another section."); }
if (n == 25) { return i18n("Identifier in use"); }
if (n == 26) { return i18n("Are you sure you want to remove section %1?"); }
if (n == 27) { return i18n("Section removal"); }

if (n == 500) { return i18n("Error"); }

return ERR;
}

QString MouseWidget :: Locale (int n)
{
if (n == 0) { return i18n("Pointer"); }
if (n == 1) { return i18n("&Change entries..."); }
if (n == 2) { return i18n("Advanced"); }
if (n == 3) { return i18n("Driver:"); }
if (n == 4) { return i18n("Device:"); }
if (n == 5) { return i18n("Driver description"); }
if (n == 6) { return i18n("Autodetect"); }
if (n == 7) { return i18n("Cannot find required input driver %1 on system. Please select another driver."); }
if (n == 8) { return i18n("Error!"); }
if (n == 9) { return i18n("Properties dialog for driver %1 is not implemented yet."); }

return ERR;
}

QString GlobalFunctions :: Locale (int n)
{
if (n == 0) { return i18n("Add pointer"); }
if (n == 1) { return i18n("Please select pointer device you wish to add from the list:"); }

if (n == 2) { return i18n("Add keyboard"); }
if (n == 3) { return i18n("Please select keyboard device you wish to add from the list:"); }

if (n == 4) { return i18n("Add screen"); }
if (n == 5) { return i18n("Please select screen you wish to add from the list:"); }

if (n == 6) { return i18n("Default ServerLayout"); }
if (n == 7) { return i18n("Please select default Server Layout from the list:"); }


if (n == 200) { return i18n("Mouse"); }

if (n == 300) { return i18n("NVidia Accelerated Graphics Driver"); }

if (n == 1000) { return i18n("No description yet!"); }
return ERR;
}

QString KeyboardWidget :: Locale(int n)
{
if (n == 0) { return i18n("Keyboard"); }
if (n == 1) { return i18n("&Change entries..."); }
if (n == 2) { return i18n("Driver:"); }
if (n == 3) { return i18n("Layout:"); }
if (n == 4) { return i18n("Model:"); }
if (n == 5) { return i18n("Device:"); }
if (n == 6) { return i18n("Protocol:"); }
if (n == 7) { return i18n("Auto Repeat:"); }
if (n == 8) { return i18n("Delay before repeating (ms):"); }
if (n == 9) { return i18n("Repeat rate:"); }
if (n == 10) { return i18n("Autodetect"); }




if (n == 999) { return i18n("Not specified"); }
if (n == 1000) { return i18n("af - Afrikaans"); }
if (n == 1001) { return i18n("ar - Arabic"); }
if (n == 1002) { return i18n("bg - Bulgarian"); }
if (n == 1003) { return i18n("bo - Tibetan"); }
if (n == 1004) { return i18n("br - Breton"); }
if (n == 1005) { return i18n("ca - Catalan"); }
if (n == 1006) { return i18n("cs - Czech"); }
if (n == 1007) { return i18n("cy - Welsh"); }
if (n == 1008) { return i18n("da - Danish"); }
if (n == 1009) { return i18n("de - German"); }
if (n == 1010) { return i18n("el - Greek"); }
if (n == 1011) { return i18n("en_GB - English (Great Britain)"); }
if (n == 1012) { return i18n("en_US - English (United States)"); }
if (n == 1013) { return i18n("eo - Esperanto"); }
if (n == 1014) { return i18n("es - Spanish"); }
if (n == 1015) { return i18n("et - Estonian"); }
if (n == 1016) { return i18n("eu - Basque"); }
if (n == 1017) { return i18n("fi - Finnish"); }
if (n == 1018) { return i18n("fr - French"); }
if (n == 1019) { return i18n("ga - Irish"); }
if (n == 1020) { return i18n("gl - Galician"); }
if (n == 1021) { return i18n("gu - Gujarati"); }
if (n == 1022) { return i18n("he - Hebrew"); }
if (n == 1023) { return i18n("hi - Hindi"); }
if (n == 1024) { return i18n("hu - Hungarian"); }
if (n == 1025) { return i18n("id - Indonesian"); }
if (n == 1026) { return i18n("is - Icelandic"); }
if (n == 1027) { return i18n("it - Italian"); }
if (n == 1028) { return i18n("ja - Japanese"); }
if (n == 1029) { return i18n("km - Cambodian"); }
if (n == 1030) { return i18n("ko - Korean"); }
if (n == 1031) { return i18n("lt - Lithuanian"); }
if (n == 1032) { return i18n("lv - Latvian (Lettish)"); }
if (n == 1033) { return i18n("mi - Maori"); }
if (n == 1034) { return i18n("mk - Macedonian"); }
if (n == 1035) { return i18n("mr - Marathi"); }
if (n == 1036) { return i18n("nl - Dutch"); }
if (n == 1037) { return i18n("no - Norwegian"); }
if (n == 1038) { return i18n("oc - Occitan"); }
if (n == 1039) { return i18n("pl - Polish"); }
if (n == 1040) { return i18n("pt - Portuguese"); }
if (n == 1041) { return i18n("ro - Romanian"); }
if (n == 1042) { return i18n("ru - Russian"); }
if (n == 1043) { return i18n("sk - Slovak"); }
if (n == 1044) { return i18n("sl - Slovenian"); }
if (n == 1045) { return i18n("sr - Serbian"); }
if (n == 1046) { return i18n("sv - Swedish"); }
if (n == 1047) { return i18n("ta - Tamil"); }
if (n == 1048) { return i18n("th - Thai"); }
if (n == 1049) { return i18n("tr - Turkish"); }
if (n == 1050) { return i18n("uk - Ukrainian"); }

if (n == 2000) { return i18n("Not specified"); }
if (n == 2001) { return i18n("PC-105"); }              //pc105
if (n == 2002) { return i18n("PC-104"); }              //pc104
if (n == 2003) { return i18n("Logicordless"); }        //logicordless
if (n == 2004) { return i18n("Macintosh"); }           //macintosh
if (n == 2005) { return i18n("PC-98"); }               //pc98
if (n == 2006) { return i18n("Solaris 8 on x86"); }    //pc101_sol8x86

if (n == 2010) { return i18n("Standard"); }            //Standard
if (n == 2011) { return i18n("Xqueue"); }              //Xqueue




return ERR;
}

QString Xorg :: Locale(int n)
{
if (n == 0) { 
QString ToRet = QString("# X Server Configuration file generated by ").append(APPNAME).append(" ").append(APPVERSION).append("\n");
ToRet = ToRet.append("# (c) ").append(APPYEAR).append(" ").append(APPAUTHOR).append("\n");


return ToRet;
}
return ERR;
}

QString VideocardWidget :: Locale(int n)
{
if (n == 0) { return i18n("Video Card"); }
if (n == 1) { return i18n("Change entries..."); }
if (n == 2) { return i18n("Advanced"); }
if (n == 3) { return i18n("Driver:"); }
if (n == 4) { return i18n("Vendor name:"); }
if (n == 5) { return i18n("Driver information"); }

return ERR;
}

QString MonitorWidget :: Locale(int n)
{
if (n == 0) { return i18n("Display"); }
if (n == 1) { return i18n("Here you can modify display properties - display modes, refresh rates, monitor information."); }
if (n == 2) { return i18n("Monitor"); }
if (n == 3) { return i18n("Screen"); }
if (n == 4) { return i18n("Monitor:"); }
if (n == 5) { return i18n("Change entries..."); }
if (n == 6) { return i18n("Vendor:"); }
if (n == 7) { return i18n("Model:"); }
if (n == 8) { return i18n("Monitor is DPMS compilant"); }
if (n == 9) { return i18n("Monitor:"); }
if (n == 10) { return i18n("Video card:"); }
if (n == 11) { return i18n("Screen:"); }
if (n == 12) { return i18n("Screen modes..."); }

return ERR;
}

QString AdvancedWidget :: Locale(int n)
{
if (n == 0) { return i18n("Advanced settings TODO"); }
if (n == 1) { return i18n("In this section you can modify advanced X properties - file paths, modules and extensions."); }
return ERR;
}

QString ScreenModesEditor :: Locale (int n)
{
if (n == 0) { return i18n("X Screen Modes Editor"); }
if (n == 1) { return i18n("Screen Modes Editor"); }
if (n == 2) { return i18n("Here you can modify screen modes and depths that X will validate on startup. Remember that X will use first validated mode on list as default."); }
if (n == 3) { return i18n("OK"); }
if (n == 4) { return i18n("Apply"); }
if (n == 5) { return i18n("Cancel"); }
if (n == 6) { return i18n("Add mode..."); }
if (n == 7) { return i18n("Settings for: "); }
if (n == 8) { return i18n("Remove mode"); }
if (n == 9) { return i18n("Display size"); }
if (n == 10) { return i18n("Refresh rates"); }
if (n == 11) { return i18n("Horizontal sync (kHz):"); }
if (n == 12) { return i18n("Vertical refresh (Hz):"); }
if (n == 13) { return i18n("Add mode..."); }
if (n == 14) { return i18n("Add mode..."); }
if (n == 15) { return i18n("Mode:"); }
if (n == 16) { return i18n("Refresh rate:"); }
return ERR;
}

QString ChangeEntriesDialog :: Locale (int n)
{
if (n == 0) { return i18n("Server Layout"); }
if (n == 1) { return i18n("Pointer"); }
if (n == 2) { return i18n("Keyboard"); }
if (n == 3) { return i18n("Device"); }
if (n == 4) { return i18n("Monitor"); }
if (n == 5) { return i18n("Screen"); }
if (n == 6) { return i18n("Entries editor - "); }
if (n == 7) { return i18n("Here you can modify all %1 sections that are present in configuration file."); }
if (n == 8) { return i18n("Entries Editor"); }
if (n == 9) { return i18n("OK"); }
if (n == 10) { return i18n("Cancel"); }
if (n == 11) { return i18n("Add"); }
if (n == 12) { return i18n("Remove"); }
if (n == 13) { return i18n("Rename"); }
if (n == 14) { return i18n("New section"); }
if (n == 15) { return i18n("Enter name for new section:"); }
if (n == 16) { return i18n("This identifier is taken."); }
if (n == 17) { return i18n("Error"); }
if (n == 18) { return i18n("Are you sure you want to remove section %1?"); }
if (n == 19) { return i18n("Section removal"); }
if (n == 20) { return i18n("There should be at least one section available."); }
if (n == 21) { return i18n("Section renaming"); }
if (n == 22) { return i18n("Enter new identifier:"); }

return ERR;
}

QString PropertiesDialog :: Locale (int n)
{
if (n == 0) { return i18n("Properties"); }
if (n == 1) { return i18n("OK"); }
if (n == 2) { return i18n("Cancel"); }
if (n == 5) { return i18n("Properties dialog for driver %1"); }

if (n == 3) { return i18n("General"); }
if (n == 4) { return i18n("Protocol:"); }
if (n == 6) { return i18n("Here you can configure mouse options. Note that these are for advanced users only, so modify them at your own risk."); }
if (n == 7) { return i18n("Autodetect"); }
if (n == 8) { return i18n("Baud rate:"); }
if (n == 9) { return i18n("Number of buttons:"); }
if (n == 10) { return i18n("Sample rate:"); }
if (n == 11) { return i18n("Resolution:"); }
if (n == 12) { return i18n("Middle button sends L+R button event"); }
if (n == 13) { return i18n("Clear DTR"); }
if (n == 14) { return i18n("Clear RTS"); }
if (n == 15) { return i18n("Flip X axis"); }
if (n == 16) { return i18n("Flip Y axis"); }
if (n == 17) { return i18n("Angle offset"); }
if (n == 18) { return i18n("Cursor motion angle offset:"); }
if (n == 19) { return i18n("Emulate 3 buttons"); }
if (n == 20) { return i18n("Timeout:"); }
if (n == 21) { return i18n("Wheel button emulation"); }
if (n == 22) { return i18n("Button:"); }
if (n == 23) { return i18n("Wheel inertia (in pixels):"); }
if (n == 24) { return i18n("Timeout (ms):"); }
if (n == 25) { return i18n("Entry:"); }
if (n == 26) { return i18n("Swap X and Y axis"); }
if (n == 27) { return i18n("Specify the mouse protocol. Not all protocols are supported on all platforms. The \"Auto\" platform specifies that protocol auto-detection should be attempted. There is no default protocol setting, and specifying this option is mandatory."); }
if (n == 28) { return i18n("Set the baud rate to use for communicating with a serial mouse. This option should rarely be required because the default is correct for almost all situations."); }
if (n == 29) { return i18n("Specifies the number of mouse buttons. In cases where the number of buttons cannot be auto-detected, the default value is 3."); }
if (n == 30) { return i18n("Sets the number of motion/button events the mouse sends per second. Setting this is only supported for some mice, including some Logitech mice and some PS/2 mice on some platforms. Default: whatever the mouse is already set to."); }
if (n == 31) { return i18n("Sets the resolution of the device in counts per inch. Setting this is only supported for some mice, including some PS/2 mice on some platforms. Default: whatever the mouse is already set to."); }
if (n == 32) { return i18n("Enable/disable handling of mice that send left+right events when the middle button is used. Default: off."); }
if (n == 33) { return i18n("Enable/disable clearing the DTR line on the serial port used by the mouse. Some dual-protocol mice require the DTR line to be cleared to operate in the non-default protocol. This option is for serial mice only. Default: off."); }
if (n == 34) { return i18n("Enable/disable clearing the RTS line on the serial port used by the mouse. Some dual-protocol mice require the RTS line to be cleared to operate in the non-default protocol. This option is for serial mice only. Default: off."); }
if (n == 35) { return i18n("Invert the X axis. Default: off."); }
if (n == 36) { return i18n("Invert the Y axis. Default: off."); }
if (n == 37) { return i18n("Enable/disable swapping the X and Y axes."); }
if (n == 38) { return i18n("Specify a clockwise angular offset (in degrees) to apply to the pointer motion."); }
if (n == 39) { return i18n("Enable/disable the emulation of the third (middle) mouse button for mice which only have two physical buttons. The third button is emulated by pressing both buttons simultaneously. Default: off"); }
if (n == 40) { return i18n("Sets the timeout (in milliseconds) that the driver waits before deciding if two buttons where pressed \"simultaneously\" when 3 button emulation is enabled. Default: 50."); }
if (n == 41) { return i18n("Enable/disable \"wheel\" emulation. Wheel emulation means emulating button press/release events when the mouse is moved while a specific real button is pressed. Wheel button events (typically buttons 4 and 5) are usually used for scrolling. Wheel emulation is useful for getting wheel-like behaviour with trackballs. It can also be useful for mice with 4 or more buttons but no wheel. Default: off."); }
if (n == 42) { return i18n("Specifies which button must be held down to enable wheel emulation mode. While this button is down, X and/or Y pointer movement will generate button press/release events."); }
if (n == 43) { return i18n("Specifies how far (in pixels) the pointer must move to generate button press/release events in wheel emulation mode. Default: 50."); }


return ERR;
}


