/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Sałaciński   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

//KDE Includes
#include <kiconloader.h>

//QT Includes
#include <qframe.h>
#include <qcheckbox.h>
#include <qgroupbox.h>
#include <qtooltip.h>

//kX Generator Includes
#include "PropertiesDialog.h"
#include "properties.h"

void PropertiesDialog :: CreateWindow(int x, int y, QString DriverName, QString IconName, QWidget *ParentWindow)
{
KIconLoader *Icons = new KIconLoader();
OptionsDialog = new KDialog(ParentWindow);

OptionsDialog->setMinimumSize(x, y);
OptionsDialog->setMaximumSize(x, y);
OptionsDialog->setPlainCaption(Locale(0));

  OKButton = new KPushButton(OptionsDialog);
  OKButton->setGeometry(x - 240, y - 39, 110, 29);
  OKButton->setText(Locale(1));
  OKButton->setIconSet(Icons->loadIcon("ok", KIcon::Desktop, KIcon::SizeSmall));
  OKButton->show();

  CancelButton = new KPushButton(OptionsDialog);
  CancelButton->setGeometry(x - 120, y - 39, 110, 29);
  CancelButton->setText(Locale(2));
  CancelButton->setIconSet(Icons->loadIcon("cancel", KIcon::Desktop, KIcon::SizeSmall));
  CancelButton->show();

   QFrame *LineBottom = new QFrame(OptionsDialog);
    LineBottom->setGeometry(QRect(10, y - 49, x - 20, 5));
    LineBottom->setFrameShape( QFrame::HLine );
    LineBottom->setFrameShadow( QFrame::Sunken );
    LineBottom->show();

    QLabel *Pixmap = new QLabel(OptionsDialog);
     Pixmap->setGeometry(x - 138, 10, 128, 128);
     Pixmap->setPixmap(Icons->loadIcon(IconName, KIcon::Desktop, KIcon::SizeEnormous));

   QLabel *LogoLabel = new QLabel(OptionsDialog);
    LogoLabel->setText(Locale(5).arg("<b><i>" + DriverName));
    LogoLabel->setFont(QFont("sans", 19, QFont::Normal, FALSE));
    LogoLabel->setGeometry(10, 10, x - 150, 35);

   QFrame *Line = new QFrame(OptionsDialog);
    Line->setGeometry(QRect(10, 45, x - 150, 5));
    Line->setFrameShape( QFrame::HLine );
    Line->setFrameShadow( QFrame::Sunken );

   InformationLabel = new QLabel(OptionsDialog);
    InformationLabel->setGeometry(10, 60, x - 150, 85);
    InformationLabel->setAlignment(QLabel::AlignTop | QLabel::WordBreak);

connect (CancelButton, SIGNAL(clicked()), OptionsDialog, SLOT(reject()));
}



void PropertiesDialog :: SetOptions_MOUSE(QWidget *Parent, Xorg *Xorg, int SectionNumber)
{
CreateWindow(600, 510, "mouse", "mouse", Parent);

SecNum = SectionNumber;
X = Xorg;

  Group[0] = new QGroupBox(OptionsDialog);
   Group[0]->setGeometry(10, 150, 300, 300);
   Group[0]->setTitle(Locale(3));
   Group[0]->show();

InformationLabel->setText(Locale(6).append("<br><br>" + Locale(25) + " <b>" + X->GetValue(Xorg::InputDevice, SectionNumber, "Identifier", 1) + "</b>"));


//Protocol label
   Label[0] = new QLabel(Group[0]);
    Label[0]->setGeometry(10, 20, 130, 25);
    Label[0]->setText(Locale(4));
    Label[0]->show();

//Protocol combo
   Combo[0] = new KComboBox(Group[0]);
    Combo[0]->setGeometry(130, 20, 160, 25);
    Combo[0]->show();

//Baud rate label
   Label[1] = new QLabel(Group[0]);
    Label[1]->setGeometry(10, 50, 130, 25);
    Label[1]->setText(Locale(8));
    Label[1]->show();

//Baud Rate
   Combo[1] = new KComboBox(Group[0]);
    Combo[1]->setGeometry(130, 50, 160, 25);
    Combo[1]->show();









///Button number

//Number of buttons label
   Label[2] = new QLabel(Group[0]);
    Label[2]->setGeometry(10, 80, 170, 25);
    Label[2]->setText(Locale(9));
    Label[2]->show();

//Number of buttons spin box
   SpinBox[0] = new KIntSpinBox(Group[0]);
    SpinBox[0]->setGeometry(130, 80, 50, 25);
    SpinBox[0]->setMinValue(0);
    SpinBox[0]->setMaxValue(24);

//Autodetect buttons check box

   Check[0] = new QCheckBox(Group[0]);
    Check[0]->setGeometry(190, 80, 100, 25);
    Check[0]->setText(Locale(7));




///Sample rate
//Sample rate label
   Label[3] = new QLabel(Group[0]);
    Label[3]->setGeometry(10, 110, 130, 25);
    Label[3]->setText(Locale(10));
    Label[3]->show();

//Sample rate spin box
   SpinBox[1] = new KIntSpinBox(Group[0]);
    SpinBox[1]->setGeometry(130, 110, 50, 25);
    SpinBox[1]->setMinValue(0);
    SpinBox[1]->setMaxValue(5000);

//Autodetect sample rate check box

   Check[1] = new QCheckBox(Group[0]);
    Check[1]->setGeometry(190, 110, 100, 25);
    Check[1]->setText(Locale(7));


///Resolution

//Resolution label
   Label[4] = new QLabel(Group[0]);
    Label[4]->setGeometry(10, 140, 130, 25);
    Label[4]->setText(Locale(11));
    Label[4]->show();

//Resolution spin box
   SpinBox[2] = new KIntSpinBox(Group[0]);
    SpinBox[2]->setGeometry(130, 140, 50, 25);
    SpinBox[2]->setMinValue(0);
    SpinBox[2]->setMaxValue(5000);

//Autodetect Resolution check box

   Check[2] = new QCheckBox(Group[0]);
    Check[2]->setGeometry(190, 140, 100, 25);
    Check[2]->setText(Locale(7));





//Middle button L+R event
   Check[3] = new QCheckBox(Group[0]);
    Check[3]->setGeometry(10, 170, 280, 25);
    Check[3]->setText(Locale(12));

//Clear DTR
   Check[4] = new QCheckBox(Group[0]);
    Check[4]->setGeometry(10, 200, 140, 25);
    Check[4]->setText(Locale(13));

//Clear RTS
   Check[5] = new QCheckBox(Group[0]);
    Check[5]->setGeometry(10, 230, 140, 25);
    Check[5]->setText(Locale(14));

//Flip X
   Check[6] = new QCheckBox(Group[0]);
    Check[6]->setGeometry(140, 200, 140, 25);
    Check[6]->setText(Locale(15));

//Flip Y
   Check[7] = new QCheckBox(Group[0]);
    Check[7]->setGeometry(140, 230, 140, 25);
    Check[7]->setText(Locale(16));

//Flip Y
   Check[8] = new QCheckBox(Group[0]);
    Check[8]->setGeometry(10, 260, 140, 25);
    Check[8]->setText(Locale(26));



   Group[1] = new QGroupBox(OptionsDialog);
    Group[1]->setGeometry(320, 150, 270, 65);
    Group[1]->setTitle(Locale(17));
    Group[1]->setCheckable(TRUE);
    Group[1]->setChecked(FALSE);

   Label[5] = new QLabel(Group[1]);
    Label[5]->setGeometry(10, 25, 200, 25);
    Label[5]->setText(Locale(18));

   SpinBox[3] = new KIntSpinBox(Group[1]);
    SpinBox[3]->setGeometry(210, 25, 50, 25);
    SpinBox[3]->setMinValue(0);
    SpinBox[3]->setMaxValue(360);



   Group[2] = new QGroupBox(OptionsDialog);
    Group[2]->setGeometry(320, 230, 270, 65);
    Group[2]->setTitle(Locale(19));
    Group[2]->setCheckable(TRUE);
    Group[2]->setChecked(FALSE);

   Label[6] = new QLabel(Group[2]);
    Label[6]->setGeometry(10, 25, 200, 25);
    Label[6]->setText(Locale(20));

   SpinBox[4] = new KIntSpinBox(Group[2]);
    SpinBox[4]->setGeometry(210, 25, 50, 25);
    SpinBox[4]->setMinValue(0);
    SpinBox[4]->setMaxValue(360);



   Group[3] = new QGroupBox(OptionsDialog);
    Group[3]->setGeometry(320, 320, 270, 130);
    Group[3]->setTitle(Locale(21));
    Group[3]->setCheckable(TRUE);
    Group[3]->setChecked(FALSE);

   Label[7] = new QLabel(Group[3]);
    Label[7]->setGeometry(10, 25, 200, 25);
    Label[7]->setText(Locale(22));

   SpinBox[5] = new KIntSpinBox(Group[3]);
    SpinBox[5]->setGeometry(210, 25, 50, 25);
    SpinBox[5]->setMinValue(0);
    SpinBox[5]->setMaxValue(24);

   Label[8] = new QLabel(Group[3]);
    Label[8]->setGeometry(10, 60, 200, 25);
    Label[8]->setText(Locale(23));

   SpinBox[6] = new KIntSpinBox(Group[3]);
    SpinBox[6]->setGeometry(210, 60, 50, 25);
    SpinBox[6]->setMinValue(0);
    SpinBox[6]->setMaxValue(2000);

   Label[9] = new QLabel(Group[3]);
    Label[9]->setGeometry(10, 95, 200, 25);
    Label[9]->setText(Locale(24));

   SpinBox[7] = new KIntSpinBox(Group[3]);
    SpinBox[7]->setGeometry(210, 95, 50, 25);
    SpinBox[7]->setMinValue(20);
    SpinBox[7]->setMaxValue(2000);



//Inserting combo box entries

    Combo[0]->insertItem("Auto");
    Combo[0]->insertItem("Microsoft");
    Combo[0]->insertItem("MouseSystems");
    Combo[0]->insertItem("MMSeries");
    Combo[0]->insertItem("Logitech");
    Combo[0]->insertItem("MouseMan");
    Combo[0]->insertItem("MMHitTab");
    Combo[0]->insertItem("GlidePoint");
    Combo[0]->insertItem("IntelliMouse");
    Combo[0]->insertItem("ThinkingMouse");
    Combo[0]->insertItem("ValuMouseScroll");
    Combo[0]->insertItem("AceCad");
    Combo[0]->insertItem("PS/2");
    Combo[0]->insertItem("ImPS/2");
    Combo[0]->insertItem("ExplorerPS/2");
    Combo[0]->insertItem("ThinkingMousePS/2");
    Combo[0]->insertItem("MouseManPlusPS/2");
    Combo[0]->insertItem("GlidePointPS/2");
    Combo[0]->insertItem("NetMousePS/2");
    Combo[0]->insertItem("NetScrollPS/2");
    Combo[0]->insertItem("BusMouse");
    Combo[0]->insertItem("SysMouse");
    Combo[0]->insertItem("WSMouse");
    Combo[0]->insertItem("USB");
    Combo[0]->insertItem("Xqueue");

    Combo[1]->insertItem(Locale(7));
    Combo[1]->insertItem("300");
    Combo[1]->insertItem("1200 (default)");
    Combo[1]->insertItem("2400");
    Combo[1]->insertItem("4800");
    Combo[1]->insertItem("9600");
    Combo[1]->insertItem("19200");





//Connecting
   connect(Check[0], SIGNAL(toggled(bool)), this, SLOT(MOUSE_ButtonsCheck(bool)));
   connect(Check[1], SIGNAL(toggled(bool)), this, SLOT(MOUSE_SampleCheck(bool)));
   connect(Check[2], SIGNAL(toggled(bool)), this, SLOT(MOUSE_ResolutionCheck(bool)));
   connect(OKButton, SIGNAL(clicked()), this, SLOT(MOUSE_SaveAndExit()));




//Initializing...
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "")                  { Combo[0]->setCurrentItem(0);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "auto")              { Combo[0]->setCurrentItem(0);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "microsoft")         { Combo[0]->setCurrentItem(1);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "mousesystems")      { Combo[0]->setCurrentItem(2);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "mmseries")          { Combo[0]->setCurrentItem(3);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "logitech")          { Combo[0]->setCurrentItem(4);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "mouseman")          { Combo[0]->setCurrentItem(5);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "mmhittab")          { Combo[0]->setCurrentItem(6);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "glidepoint")        { Combo[0]->setCurrentItem(7);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "intellimouse")      { Combo[0]->setCurrentItem(8);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "thinkingmouse")     { Combo[0]->setCurrentItem(9);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "valumousescroll")   { Combo[0]->setCurrentItem(10); }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "acecad")            { Combo[0]->setCurrentItem(11); }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "ps/2")              { Combo[0]->setCurrentItem(12); }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "imps/2")            { Combo[0]->setCurrentItem(13); }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "explorerps/2")      { Combo[0]->setCurrentItem(14); }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "thinkingmouseps/2") { Combo[0]->setCurrentItem(15); }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "mousemanplusps/2")  { Combo[0]->setCurrentItem(16); }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "glidepointps/2")    { Combo[0]->setCurrentItem(17); }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "netmouseps/2")      { Combo[0]->setCurrentItem(18); }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "netscrollps/2")     { Combo[0]->setCurrentItem(19); }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "busmouse")          { Combo[0]->setCurrentItem(20); }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "sysmouse")          { Combo[0]->setCurrentItem(21); }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "wsmouse")           { Combo[0]->setCurrentItem(22); }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "usb")               { Combo[0]->setCurrentItem(23); }
if (X->GetOption(Xorg::InputDevice, SecNum, "Protocol").lower() == "xqueue")            { Combo[0]->setCurrentItem(24); }

if (X->GetOption(Xorg::InputDevice, SecNum, "BaudRate").lower() == "")                  { Combo[1]->setCurrentItem(0);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "BaudRate").lower() == "300")               { Combo[1]->setCurrentItem(1);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "BaudRate").lower() == "1200")              { Combo[1]->setCurrentItem(2);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "BaudRate").lower() == "2400")              { Combo[1]->setCurrentItem(3);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "BaudRate").lower() == "4800")              { Combo[1]->setCurrentItem(4);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "BaudRate").lower() == "9600")              { Combo[1]->setCurrentItem(5);  }
if (X->GetOption(Xorg::InputDevice, SecNum, "BaudRate").lower() == "19200")             { Combo[1]->setCurrentItem(6);  }




bool ok;

if (X->GetOption(Xorg::InputDevice, SecNum, "Buttons") == "") 
{ Check[0]->setChecked(TRUE); }
else
{ Check[0]->setChecked(FALSE); SpinBox[0]->setValue(X->GetOption(Xorg::InputDevice, SecNum, "Buttons").toInt(&ok, 10)); }



if (X->GetOption(Xorg::InputDevice, SecNum, "SampleRate") == "") 
{ Check[1]->setChecked(TRUE); }
else
{ Check[1]->setChecked(FALSE); SpinBox[1]->setValue(X->GetOption(Xorg::InputDevice, SecNum, "SampleRate").toInt(&ok, 10)); }


if (X->GetOption(Xorg::InputDevice, SecNum, "Resolution") == "") 
{ Check[2]->setChecked(TRUE); }
else
{ Check[2]->setChecked(FALSE); SpinBox[2]->setValue(X->GetOption(Xorg::InputDevice, SecNum, "Resolution").toInt(&ok, 10)); }


if (X->GetOption(Xorg::InputDevice, SecNum, "AngleOffset") == "") 
{ Group[1]->setChecked(FALSE); }
else
{ Group[1]->setChecked(TRUE); SpinBox[3]->setValue(X->GetOption(Xorg::InputDevice, SecNum, "AngleOffset").toInt(&ok, 10)); }



if (X->GetBoolOption(Xorg::InputDevice, SecNum, "Emulate3Buttons"))
{
Group[2]->setChecked(TRUE);
  if (X->GetOption(Xorg::InputDevice, SecNum, "Emulate3Timeout") != "")
   {
    SpinBox[4]->setValue(X->GetOption(Xorg::InputDevice, SecNum, "Emulate3Timeout").toInt(&ok, 10));
   }
  else
   {
    SpinBox[4]->setValue(50);                 //Default
   }

}

if (X->GetBoolOption(Xorg::InputDevice, SecNum, "EmulateWheel")) 
{
Group[3]->setChecked(TRUE);

  if (X->GetOption(Xorg::InputDevice, SecNum, "EmulateWheelButton") != "")
   {
    SpinBox[5]->setValue(X->GetOption(Xorg::InputDevice, SecNum, "EmulateWheelButton").toInt(&ok, 10));
   }
  else
   {
    SpinBox[5]->setValue(4);                 //Default
   }

  if (X->GetOption(Xorg::InputDevice, SecNum, "EmulateWheelInertia") != "")
   {
    SpinBox[6]->setValue(X->GetOption(Xorg::InputDevice, SecNum, "EmulateWheelInertia").toInt(&ok, 10));
   }
  else
   {
    SpinBox[6]->setValue(50);                 //Default
   }

  if (X->GetOption(Xorg::InputDevice, SecNum, "EmulateWheelTimeout") != "")
   {
    SpinBox[7]->setValue(X->GetOption(Xorg::InputDevice, SecNum, "EmulateWheelTimeout").toInt(&ok, 10));
   }
  else
   {
    SpinBox[7]->setValue(300);                 //Default
   }

}




if (X->GetBoolOption(Xorg::InputDevice, SecNum, "ChordMiddle"))             { Check[3]->setChecked(TRUE); }
if (!X->GetBoolOption(Xorg::InputDevice, SecNum, "ChordMiddle"))            { Check[3]->setChecked(FALSE); }
if (X->GetBoolOption(Xorg::InputDevice, SecNum, "ClearDTR"))                { Check[4]->setChecked(TRUE); }
if (!X->GetBoolOption(Xorg::InputDevice, SecNum, "ClearDTR"))               { Check[4]->setChecked(FALSE); }
if (X->GetBoolOption(Xorg::InputDevice, SecNum, "ClearRTS"))                { Check[5]->setChecked(TRUE); }
if (!X->GetBoolOption(Xorg::InputDevice, SecNum, "ClearRTS"))               { Check[5]->setChecked(FALSE); }
if (X->GetBoolOption(Xorg::InputDevice, SecNum, "InvX"))                    { Check[6]->setChecked(TRUE); }
if (!X->GetBoolOption(Xorg::InputDevice, SecNum, "InvX"))                   { Check[6]->setChecked(FALSE); }
if (X->GetBoolOption(Xorg::InputDevice, SecNum, "InvY"))                    { Check[7]->setChecked(TRUE); }
if (!X->GetBoolOption(Xorg::InputDevice, SecNum, "InvY"))                   { Check[7]->setChecked(FALSE); }
if (X->GetBoolOption(Xorg::InputDevice, SecNum, "FlipXY"))                  { Check[8]->setChecked(TRUE); }
if (!X->GetBoolOption(Xorg::InputDevice, SecNum, "FlipXY"))                 { Check[8]->setChecked(FALSE); }


//Adding tooltips

QToolTip::add(Combo[0], "<b>" + Locale(4).remove(":") + "</b><br><br>" + Locale(27));
QToolTip::add(Combo[1], "<b>" + Locale(8).remove(":") + "</b><br><br>" + Locale(28));
QToolTip::add(SpinBox[0], "<b>" + Locale(9).remove(":") + "</b><br><br>" + Locale(29));
QToolTip::add(SpinBox[1], "<b>" + Locale(10).remove(":") + "</b><br><br>" + Locale(30));
QToolTip::add(SpinBox[2], "<b>" + Locale(11).remove(":") + "</b><br><br>" + Locale(31));
QToolTip::add(Check[3], "<b>" + Locale(12).remove(":") + "</b><br><br>" + Locale(32));
QToolTip::add(Check[4], "<b>" + Locale(13).remove(":") + "</b><br><br>" + Locale(33));
QToolTip::add(Check[5], "<b>" + Locale(14).remove(":") + "</b><br><br>" + Locale(34));
QToolTip::add(Check[6], "<b>" + Locale(15).remove(":") + "</b><br><br>" + Locale(35));
QToolTip::add(Check[7], "<b>" + Locale(16).remove(":") + "</b><br><br>" + Locale(36));
QToolTip::add(Check[8], "<b>" + Locale(26).remove(":") + "</b><br><br>" + Locale(37));
QToolTip::add(Group[1], "<b>" + Locale(17).remove(":") + "</b><br><br>" + Locale(38));
QToolTip::add(SpinBox[3], "<b>" + Locale(17).remove(":") + "</b><br><br>" + Locale(38));
QToolTip::add(Group[2], "<b>" + Locale(19).remove(":") + "</b><br><br>" + Locale(39));
QToolTip::add(SpinBox[4], "<b>" + Locale(20).remove(":") + "</b><br><br>" + Locale(40));
QToolTip::add(Group[3], "<b>" + Locale(21).remove(":") + "</b><br><br>" + Locale(41));
QToolTip::add(SpinBox[5], "<b>" + Locale(22).remove(":") + "</b><br><br>" + Locale(42));
QToolTip::add(SpinBox[6], "<b>" + Locale(23).remove(":") + "</b><br><br>" + Locale(43));
OptionsDialog->exec();
}



void PropertiesDialog :: MOUSE_ButtonsCheck(bool Checked)
{
if (Checked)
  {
   Label[2]->setEnabled(FALSE);
   SpinBox[0]->setEnabled(FALSE);
  }
else
  {
   Label[2]->setEnabled(TRUE);
   SpinBox[0]->setEnabled(TRUE);
  }
}

void PropertiesDialog :: MOUSE_SampleCheck(bool Checked)
{
if (Checked)
  {
   Label[3]->setEnabled(FALSE);
   SpinBox[1]->setEnabled(FALSE);
  }
else
  {
   Label[3]->setEnabled(TRUE);
   SpinBox[1]->setEnabled(TRUE);
  }
}

void PropertiesDialog :: MOUSE_ResolutionCheck(bool Checked)
{
if (Checked)
  {
   Label[4]->setEnabled(FALSE);
   SpinBox[2]->setEnabled(FALSE);
  }
else
  {
   Label[4]->setEnabled(TRUE);
   SpinBox[2]->setEnabled(TRUE);
  }
}

void PropertiesDialog :: MOUSE_SaveAndExit()
{
QString Num;

    if (Combo[0]->currentItem() == 0)            { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "Auto"); }
    if (Combo[0]->currentItem() == 1)            { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "Microsoft"); }
    if (Combo[0]->currentItem() == 2)            { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "MouseSystems"); }
    if (Combo[0]->currentItem() == 3)            { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "MMSeries"); }
    if (Combo[0]->currentItem() == 4)            { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "Logitech"); }
    if (Combo[0]->currentItem() == 5)            { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "MouseMan"); }
    if (Combo[0]->currentItem() == 6)            { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "MMHitTab"); }
    if (Combo[0]->currentItem() == 7)            { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "GlidePoint"); }
    if (Combo[0]->currentItem() == 8)            { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "IntelliMouse"); }
    if (Combo[0]->currentItem() == 9)            { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "ThinkingMouse"); }
    if (Combo[0]->currentItem() == 10)           { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "ValuMouseScroll"); }
    if (Combo[0]->currentItem() == 11)           { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "AceCad"); }
    if (Combo[0]->currentItem() == 12)           { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "PS/2"); }
    if (Combo[0]->currentItem() == 13)           { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "ImPS/2"); }
    if (Combo[0]->currentItem() == 14)           { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "ExplorerPS/2"); }
    if (Combo[0]->currentItem() == 15)           { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "ThinkingMousePS/2"); }
    if (Combo[0]->currentItem() == 16)           { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "MouseManPlusPS/2"); }
    if (Combo[0]->currentItem() == 17)           { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "GlidePointPS/2"); }
    if (Combo[0]->currentItem() == 18)           { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "NetMousePS/2"); }
    if (Combo[0]->currentItem() == 19)           { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "NetScrollPS/2"); }
    if (Combo[0]->currentItem() == 20)           { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "BusMouse"); }
    if (Combo[0]->currentItem() == 21)           { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "SysMouse"); }
    if (Combo[0]->currentItem() == 22)           { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "WSMouse"); }
    if (Combo[0]->currentItem() == 23)           { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "USB"); }
    if (Combo[0]->currentItem() == 24)           { X->WriteOption(Xorg::InputDevice, SecNum, "Protocol", "Xqueue"); }


    if (Combo[1]->currentItem() == 0) { X->RemoveOption(Xorg::InputDevice, SecNum, "BaudRate");   }
    if (Combo[1]->currentItem() == 1) { X->WriteOption(Xorg::InputDevice, SecNum, "BaudRate", "300");   }
    if (Combo[1]->currentItem() == 2) { X->WriteOption(Xorg::InputDevice, SecNum, "BaudRate", "1200");  }
    if (Combo[1]->currentItem() == 3) { X->WriteOption(Xorg::InputDevice, SecNum, "BaudRate", "2400");  }
    if (Combo[1]->currentItem() == 4) { X->WriteOption(Xorg::InputDevice, SecNum, "BaudRate", "4800");  }
    if (Combo[1]->currentItem() == 5) { X->WriteOption(Xorg::InputDevice, SecNum, "BaudRate", "9600");  }
    if (Combo[1]->currentItem() == 6) { X->WriteOption(Xorg::InputDevice, SecNum, "BaudRate", "19200"); }

    if (Check[0]->isChecked()) 
     { X->RemoveOption(Xorg::InputDevice, SecNum, "Buttons"); }
    else
     { X->WriteOption(Xorg::InputDevice, SecNum, "Buttons", Num.setNum(SpinBox[0]->value(), 10)); }

    if (Check[1]->isChecked()) 
     { X->RemoveOption(Xorg::InputDevice, SecNum, "SampleRate"); }
    else
     { X->WriteOption(Xorg::InputDevice, SecNum, "SampleRate", Num.setNum(SpinBox[1]->value(), 10)); }

    if (Check[2]->isChecked()) 
     { X->RemoveOption(Xorg::InputDevice, SecNum, "Resolution"); }
    else
     { X->WriteOption(Xorg::InputDevice, SecNum, "Resolution", Num.setNum(SpinBox[2]->value(), 10)); }



    if (Check[3]->isChecked())
     { X->WriteOption(Xorg::InputDevice, SecNum, "ChordMiddle", BOOL_TRUE); }
    else
     { X->RemoveOption(Xorg::InputDevice, SecNum, "ChordMiddle"); }

    if (Check[4]->isChecked())
     { X->WriteOption(Xorg::InputDevice, SecNum, "ClearDTR", BOOL_TRUE); }
    else
     { X->RemoveOption(Xorg::InputDevice, SecNum, "ClearDTR"); }

    if (Check[5]->isChecked())
     { X->WriteOption(Xorg::InputDevice, SecNum, "ClearRTS", BOOL_TRUE); }
    else
     { X->RemoveOption(Xorg::InputDevice, SecNum, "ClearRTS"); }

    if (Check[6]->isChecked())
     { X->WriteOption(Xorg::InputDevice, SecNum, "InvX", BOOL_TRUE); }
    else
     { X->RemoveOption(Xorg::InputDevice, SecNum, "InvX"); }

    if (Check[7]->isChecked())
     { X->WriteOption(Xorg::InputDevice, SecNum, "InvY", BOOL_TRUE); }
    else
     { X->RemoveOption(Xorg::InputDevice, SecNum, "InvY"); }

    if (Check[8]->isChecked())
     { X->WriteOption(Xorg::InputDevice, SecNum, "FlipXY", BOOL_TRUE); }
    else
     { X->RemoveOption(Xorg::InputDevice, SecNum, "FlipXY"); }


    if (Group[1]->isChecked())
     { X->WriteOption(Xorg::InputDevice, SecNum, "AngleOffset", Num.setNum(SpinBox[3]->value(), 10)); }
    else
     { X->RemoveOption(Xorg::InputDevice, SecNum, "AngleOffset"); }

    if (Group[2]->isChecked())
     { X->WriteOption(Xorg::InputDevice, SecNum, "Emulate3Buttons", BOOL_TRUE);
       X->WriteOption(Xorg::InputDevice, SecNum, "Emulate3Timeout", Num.setNum(SpinBox[4]->value(), 10)); }
    else
     { X->RemoveOption(Xorg::InputDevice, SecNum, "Emulate3Buttons");
       X->RemoveOption(Xorg::InputDevice, SecNum, "Emulate3Timeout"); }



    if (Group[3]->isChecked())
     { X->WriteOption(Xorg::InputDevice, SecNum, "EmulateWheel", BOOL_TRUE);
       X->WriteOption(Xorg::InputDevice, SecNum, "EmulateWheelButton", Num.setNum(SpinBox[5]->value(), 10));
       X->WriteOption(Xorg::InputDevice, SecNum, "EmulateWheelInertia", Num.setNum(SpinBox[6]->value(), 10));
       X->WriteOption(Xorg::InputDevice, SecNum, "EmulateWheelTimeout", Num.setNum(SpinBox[7]->value(), 10)); }
    else
     { X->RemoveOption(Xorg::InputDevice, SecNum, "EmulateWheel");
       X->RemoveOption(Xorg::InputDevice, SecNum, "EmulateWheelButton");
       X->RemoveOption(Xorg::InputDevice, SecNum, "EmulateWheelInertia");
       X->RemoveOption(Xorg::InputDevice, SecNum, "EmulateWheelTimeout"); }










OptionsDialog->close();
}
